/*!
 * Uploader - Uploader library implements html5 file upload and provides multiple simultaneous, stable, fault tolerant and resumable uploads
 * @version v0.4.0
 * @author dolymood <dolymood@gmail.com>
 * @link https://github.com/simple-uploader/Uploader
 * @license MIT
 */
!function(e){if("object"==typeof exports)module.exports=e();else if("function"==typeof define&&define.amd)define(e);else{var t;"undefined"!=typeof window?t=window:"undefined"!=typeof global?t=global:"undefined"!=typeof self&&(t=self),t.Uploader=e()}}(function(){return function r(n,a,o){function h(i,e){if(!a[i]){if(!n[i]){var t="function"==typeof require&&require;if(!e&&t)return t(i,!0);if(u)return u(i,!0);throw new Error("Cannot find module '"+i+"'")}var s=a[i]={exports:{}};n[i][0].call(s.exports,function(e){var t=n[i][1][e];return h(t||e)},s,s.exports,r,n,a,o)}return a[i].exports}for(var u="function"==typeof require&&require,e=0;e<o.length;e++)h(o[e]);return h}({1:[function(e,t,i){var h=e("./utils");function s(e,t,i){h.defineNonEnumerable(this,"uploader",e),h.defineNonEnumerable(this,"file",t),h.defineNonEnumerable(this,"bytes",null),this.offset=i,this.tested=!1,this.retries=0,this.pendingRetry=!1,this.preprocessState=0,this.readState=0,this.loaded=0,this.total=0,this.chunkSize=this.uploader.opts.chunkSize,this.startByte=this.offset*this.chunkSize,this.endByte=this.computeEndByte(),this.xhr=null}var a=s.STATUS={PENDING:"pending",UPLOADING:"uploading",READING:"reading",SUCCESS:"success",ERROR:"error",COMPLETE:"complete",PROGRESS:"progress",RETRY:"retry"};h.extend(s.prototype,{_event:function(e,t){(t=h.toArray(arguments)).unshift(this),this.file._chunkEvent.apply(this.file,t)},computeEndByte:function(){var e=Math.min(this.file.size,(this.offset+1)*this.chunkSize);return this.file.size-e<this.chunkSize&&!this.uploader.opts.forceChunkSize&&(e=this.file.size),e},getParams:function(){return{chunkNumber:this.offset+1,chunkSize:this.uploader.opts.chunkSize,currentChunkSize:this.endByte-this.startByte,totalSize:this.file.size,identifier:this.file.uniqueIdentifier,filename:this.file.name,relativePath:this.file.relativePath,totalChunks:this.file.chunks.length}},getTarget:function(e,t){return t.length?(e.indexOf("?")<0?e+="?":e+="&",e+t.join("&")):e},test:function(){this.xhr=new XMLHttpRequest,this.xhr.addEventListener("load",s,!1),this.xhr.addEventListener("error",s,!1);var e=h.evalOpts(this.uploader.opts.testMethod,this.file,this),t=this.prepareXhrRequest(e,!0);this.xhr.send(t);var i=this;function s(e){var t=i.status(!0);t===a.ERROR?(i._event(t,i.message()),i.uploader.uploadNextChunk()):t===a.SUCCESS?(i._event(t,i.message()),i.tested=!0):i.file.paused||(i.tested=!0,i.send())}},preprocessFinished:function(){this.endByte=this.computeEndByte(),this.preprocessState=2,this.send()},readFinished:function(e){this.readState=2,this.bytes=e,this.send()},send:function(){var e=this.uploader.opts.preprocess,t=this.uploader.opts.readFileFn;if(h.isFunction(e))switch(this.preprocessState){case 0:return this.preprocessState=1,void e(this);case 1:return}switch(this.readState){case 0:return this.readState=1,void t(this.file,this.file.fileType,this.startByte,this.endByte,this);case 1:return}if(!this.uploader.opts.testChunks||this.tested){this.loaded=0,this.total=0,this.pendingRetry=!1,this.xhr=new XMLHttpRequest,this.xhr.upload.addEventListener("progress",function(e){e.lengthComputable&&(r.loaded=e.loaded,r.total=e.total);r._event(a.PROGRESS,e)},!1),this.xhr.addEventListener("load",n,!1),this.xhr.addEventListener("error",n,!1);var i=h.evalOpts(this.uploader.opts.uploadMethod,this.file,this),s=this.prepareXhrRequest(i,!1,this.uploader.opts.method,this.bytes);this.xhr.send(s);var r=this}else this.test();function n(e){var t=r.message();r.processingResponse=!0,r.uploader.opts.processResponse(t,function(e,t){if(r.processingResponse=!1,r.xhr){r.processedState={err:e,res:t};var i=r.status();if(i===a.SUCCESS||i===a.ERROR)delete this.data,r._event(i,t),i===a.ERROR&&r.uploader.uploadNextChunk();else{r._event(a.RETRY,t),r.pendingRetry=!0,r.abort(),r.retries++;var s=r.uploader.opts.chunkRetryInterval;null!==s?setTimeout(function(){r.send()},s):r.send()}}})}},abort:function(){var e=this.xhr;this.xhr=null,this.processingResponse=!1,this.processedState=null,e&&e.abort()},status:function(e){if(1===this.readState)return a.READING;if(this.pendingRetry||1===this.preprocessState)return a.UPLOADING;if(this.xhr){if(this.xhr.readyState<4||this.processingResponse)return a.UPLOADING;var t;-1<this.uploader.opts.successStatuses.indexOf(this.xhr.status)?t=a.SUCCESS:-1<this.uploader.opts.permanentErrors.indexOf(this.xhr.status)||!e&&this.retries>=this.uploader.opts.maxChunkRetries?t=a.ERROR:(this.abort(),t=a.PENDING);var i=this.processedState;return i&&i.err&&(t=a.ERROR),t}return a.PENDING},message:function(){return this.xhr?this.xhr.responseText:""},progress:function(){if(this.pendingRetry)return 0;var e=this.status();return e===a.SUCCESS||e===a.ERROR?1:e===a.PENDING?0:0<this.total?this.loaded/this.total:0},sizeUploaded:function(){var e=this.endByte-this.startByte;return this.status()!==a.SUCCESS&&(e=this.progress()*e),e},prepareXhrRequest:function(e,t,i,s){var r=h.evalOpts(this.uploader.opts.query,this.file,this,t);r=h.extend(this.getParams(),r),r=this.uploader.opts.processParams(r);var n=h.evalOpts(this.uploader.opts.target,this.file,this,t),a=null;if("GET"===e||"octet"===i){var o=[];h.each(r,function(e,t){o.push([encodeURIComponent(t),encodeURIComponent(e)].join("="))}),n=this.getTarget(n,o),a=s||null}else a=new FormData,h.each(r,function(e,t){a.append(t,e)}),a.append(this.uploader.opts.fileParameterName,s,this.file.name);return this.xhr.open(e,n,!0),this.xhr.withCredentials=this.uploader.opts.withCredentials,h.each(h.evalOpts(this.uploader.opts.headers,this.file,this,t),function(e,t){this.xhr.setRequestHeader(t,e)},this),a}}),t.exports=s},{"./utils":5}],2:[function(e,t,i){var r=e("./utils").each,s={_eventData:null,on:function(e,t){this._eventData||(this._eventData={}),this._eventData[e]||(this._eventData[e]=[]);var i=!1;r(this._eventData[e],function(e){if(e===t)return!(i=!0)}),i||this._eventData[e].push(t)},off:function(i,s){this._eventData||(this._eventData={}),this._eventData[i]&&this._eventData[i].length&&(s?r(this._eventData[i],function(e,t){if(e===s)return this._eventData[i].splice(t,1),!1},this):this._eventData[i]=[])},trigger:function(e){if(this._eventData||(this._eventData={}),!this._eventData[e])return!0;var t=this._eventData[e].slice.call(arguments,1),i=!1;return r(this._eventData[e],function(e){i=!1===e.apply(this,t)||i},this),!i}};t.exports=s},{"./utils":5}],3:[function(e,t,i){var h=e("./utils"),s=e("./event"),n=e("./file"),a=e("./chunk"),r="undefined"==typeof window,o=!r&&window.navigator.msPointerEnabled,u=function(){if(r)return!1;var t="slice",e=h.isDefined(window.File)&&h.isDefined(window.Blob)&&h.isDefined(window.FileList),i=null;return e&&(i=window.Blob.prototype,h.each(["slice","webkitSlice","mozSlice"],function(e){if(i[e])return t=e,!1}),e=!!i[t]),e&&(p.sliceName=t),i=null,e}(),l=function(){if(r)return!1;var e=window.document.createElement("input");e.type="file";var t="webkitdirectory"in e||"directory"in e;return e=null,t}();function p(e){this.support=u,this.support&&(this.supportDirectory=l,h.defineNonEnumerable(this,"filePaths",{}),this.opts=h.extend({},p.defaults,e||{}),this.preventEvent=h.bind(this._preventEvent,this),n.call(this,this))}p.version="0.4.0",p.defaults={chunkSize:1048576,forceChunkSize:!1,simultaneousUploads:3,singleFile:!1,fileParameterName:"file",progressCallbacksInterval:500,speedSmoothingFactor:.1,query:{},headers:{},withCredentials:!1,preprocess:null,method:"multipart",testMethod:"GET",uploadMethod:"POST",prioritizeFirstAndLastChunk:!1,allowDuplicateUploads:!1,target:"/",testChunks:!0,generateUniqueIdentifier:null,maxChunkRetries:0,chunkRetryInterval:null,permanentErrors:[404,415,500,501],successStatuses:[200,201,202],onDropStopPropagation:!1,initFileFn:null,readFileFn:function(e,t,i,s,r){r.readFinished(e.file[p.sliceName](i,s,t))},checkChunkUploadedByResponse:null,initialPaused:!1,processResponse:function(e,t){t(null,e)},processParams:function(e){return e}},p.utils=h,p.event=s,p.File=n,p.Chunk=a,p.prototype=h.extend({},n.prototype),h.extend(p.prototype,s),h.extend(p.prototype,{constructor:p,_trigger:function(e){var t=h.toArray(arguments),i=!this.trigger.apply(this,arguments);return"catchAll"!==e&&(t.unshift("catchAll"),i=!this.trigger.apply(this,t)||i),!i},_triggerAsync:function(){var e=arguments;h.nextTick(function(){this._trigger.apply(this,e)},this)},addFiles:function(e,s){var r=[],t=this.fileList.length;h.each(e,function(e){if((!o||o&&0<e.size)&&(e.size%4096!=0||"."!==e.name&&"."!==e.fileName)){var t=this.generateUniqueIdentifier(e);if(this.opts.allowDuplicateUploads||!this.getFromUniqueIdentifier(t)){var i=new n(this,e,this);i.uniqueIdentifier=t,this._trigger("fileAdded",i,s)?r.push(i):n.prototype.removeFile.call(this,i)}}},this);var i=this.fileList.slice(t);this._trigger("filesAdded",r,i,s)?(h.each(r,function(e){this.opts.singleFile&&0<this.files.length&&this.removeFile(this.files[0]),this.files.push(e)},this),this._trigger("filesSubmitted",r,i,s)):h.each(i,function(e){n.prototype.removeFile.call(this,e)},this)},addFile:function(e,t){this.addFiles([e],t)},cancel:function(){for(var e=this.fileList.length-1;0<=e;e--)this.fileList[e].cancel()},removeFile:function(e){n.prototype.removeFile.call(this,e),this._trigger("fileRemoved",e)},generateUniqueIdentifier:function(e){var t=this.opts.generateUniqueIdentifier;if(h.isFunction(t))return t(e);var i=e.relativePath||e.webkitRelativePath||e.fileName||e.name;return e.size+"-"+i.replace(/[^0-9a-zA-Z_-]/gim,"")},getFromUniqueIdentifier:function(t){var i=!1;return h.each(this.files,function(e){if(e.uniqueIdentifier===t)return i=e,!1}),i},uploadNextChunk:function(e){var t=!1,i=a.STATUS.PENDING,s=this.uploader.opts.checkChunkUploadedByResponse;if(this.opts.prioritizeFirstAndLastChunk&&(h.each(this.files,function(e){if(!e.paused&&(!s||e._firstResponse||!e.isUploading()))return e.chunks.length&&e.chunks[0].status()===i?(e.chunks[0].send(),!(t=!0)):1<e.chunks.length&&e.chunks[e.chunks.length-1].status()===i?(e.chunks[e.chunks.length-1].send(),!(t=!0)):void 0}),t))return t;if(h.each(this.files,function(e){if(!e.paused){if(s&&!e._firstResponse&&e.isUploading())return;h.each(e.chunks,function(e){if(e.status()===i)return e.send(),!(t=!0)})}if(t)return!1}),t)return!0;var r=!1;return h.each(this.files,function(e){if(!e.isComplete())return!(r=!0)}),r||e||this._triggerAsync("complete"),r},upload:function(e){var t=this._shouldUploadNext();if(!1!==t){!e&&this._trigger("uploadStart");for(var i=!1,s=1;s<=this.opts.simultaneousUploads-t&&((i=this.uploadNextChunk(!e)||i)||!e);s++);i||e||this._triggerAsync("complete")}},_shouldUploadNext:function(){var t=0,i=!0,s=this.opts.simultaneousUploads,r=a.STATUS.UPLOADING;return h.each(this.files,function(e){return h.each(e.chunks,function(e){if(e.status()===r&&s<=++t)return i=!1}),i}),i&&t},assignBrowse:function(e,r,n,a){void 0===e.length&&(e=[e]),h.each(e,function(t){var i;"INPUT"===t.tagName&&"file"===t.type?i=t:((i=document.createElement("input")).setAttribute("type","file"),h.extend(i.style,{visibility:"hidden",position:"absolute",width:"1px",height:"1px"}),t.appendChild(i),t.addEventListener("click",function(e){"label"!==t.tagName.toLowerCase()&&i.click()},!1)),this.opts.singleFile||n||i.setAttribute("multiple","multiple"),r&&i.setAttribute("webkitdirectory","webkitdirectory"),a&&h.each(a,function(e,t){i.setAttribute(t,e)});var s=this;i.addEventListener("change",function(e){s._trigger(e.type,e),e.target.value&&(s.addFiles(e.target.files,e),e.target.value="")},!1)},this)},onDrop:function(e){this._trigger(e.type,e),this.opts.onDropStopPropagation&&e.stopPropagation(),e.preventDefault(),this._parseDataTransfer(e.dataTransfer,e)},_parseDataTransfer:function(e,t){e.items&&e.items[0]&&e.items[0].webkitGetAsEntry?this.webkitReadDataTransfer(e,t):this.addFiles(e.files,t)},webkitReadDataTransfer:function(e,t){var i=this,s=e.items.length,r=[];function n(e,t){e.relativePath=t.substring(1),r.push(e),o()}function a(e){throw e}function o(){0==--s&&i.addFiles(r,t)}h.each(e.items,function(e){var t=e.webkitGetAsEntry();t?t.isFile?n(e.getAsFile(),t.fullPath):function i(t){t.readEntries(function(e){e.length?(s+=e.length,h.each(e,function(e){if(e.isFile){var t=e.fullPath;e.file(function(e){n(e,t)},a)}else e.isDirectory&&i(e.createReader())}),i(t)):o()},a)}(t.createReader()):o()})},_assignHelper:function(e,t,i){void 0===e.length&&(e=[e]);var s=i?"removeEventListener":"addEventListener";h.each(e,function(i){h.each(t,function(e,t){i[s](t,e,!1)},this)},this)},_preventEvent:function(e){h.preventEvent(e),this._trigger(e.type,e)},assignDrop:function(e){this._onDrop=h.bind(this.onDrop,this),this._assignHelper(e,{dragover:this.preventEvent,dragenter:this.preventEvent,dragleave:this.preventEvent,drop:this._onDrop})},unAssignDrop:function(e){this._assignHelper(e,{dragover:this.preventEvent,dragenter:this.preventEvent,dragleave:this.preventEvent,drop:this._onDrop},!0),this._onDrop=null}}),t.exports=p},{"./chunk":1,"./event":2,"./file":4,"./utils":5}],4:[function(e,t,i){var n=e("./utils"),u=e("./chunk");function a(e,t,i){n.defineNonEnumerable(this,"uploader",e),this.isRoot=this.isFolder=e===this,n.defineNonEnumerable(this,"parent",i||null),n.defineNonEnumerable(this,"files",[]),n.defineNonEnumerable(this,"fileList",[]),n.defineNonEnumerable(this,"chunks",[]),n.defineNonEnumerable(this,"_errorFiles",[]),n.defineNonEnumerable(this,"file",null),this.id=n.uid(),this.isRoot||!t?this.file=null:n.isString(t)?(this.isFolder=!0,this.file=null,this.path=t,this.parent.path&&(t=t.substr(this.parent.path.length)),this.name="/"===t.charAt(t.length-1)?t.substr(0,t.length-1):t):(this.file=t,this.fileType=this.file.type,this.name=t.fileName||t.name,this.size=t.size,this.relativePath=t.relativePath||t.webkitRelativePath||this.name,this._parseFile()),this.paused=e.opts.initialPaused,this.error=!1,this.allError=!1,this.aborted=!1,this.averageSpeed=0,this.currentSpeed=0,this._lastProgressCallback=Date.now(),this._prevUploadedSize=0,this._prevProgress=0,this.bootstrap()}n.extend(a.prototype,{_parseFile:function(){var s=function(e){var t=[],i=e.split("/"),s=i.length,r=1;if(i.splice(s-1,1),s--,i.length)for(;r<=s;)t.push(i.slice(0,r++).join("/")+"/");return t}(this.relativePath);if(s.length){var r=this.uploader.filePaths;n.each(s,function(e,t){var i=r[e];i||(i=new a(this.uploader,e,this.parent),r[e]=i,this._updateParentFileList(i)),(this.parent=i).files.push(this),s[t+1]||i.fileList.push(this)},this)}else this._updateParentFileList()},_updateParentFileList:function(e){e||(e=this);var t=this.parent;t&&t.fileList.push(e)},_eachAccess:function(i,e){this.isFolder?n.each(this.files,function(e,t){return i.call(this,e,t)},this):e.call(this,this)},bootstrap:function(){if(!this.isFolder){var e=this.uploader.opts;n.isFunction(e.initFileFn)&&e.initFileFn.call(this,this),this.abort(!0),this._resetError(),this._prevProgress=0;for(var t=e.forceChunkSize?Math.ceil:Math.floor,i=Math.max(t(this.size/e.chunkSize),1),s=0;s<i;s++)this.chunks.push(new u(this.uploader,this,s))}},_measureSpeed:function(e){var t=0,i=0,s=0;this._eachAccess(function(e){e.paused||e.error||(s+=1,t+=e.averageSpeed||0,i+=e.currentSpeed||0)},function(){var e=Date.now()-this._lastProgressCallback;if(e){var t=this.uploader.opts.speedSmoothingFactor,i=this.sizeUploaded();this.currentSpeed=Math.max((i-this._prevUploadedSize)/e*1e3,0),this.averageSpeed=t*this.currentSpeed+(1-t)*this.averageSpeed,this._prevUploadedSize=i}}),this.isFolder&&(s?(this.currentSpeed=i/s,this.averageSpeed=t/s):(this.currentSpeed=0,this.averageSpeed=0)),this.parent&&(e||this.parent._checkProgress())&&this.parent._measureSpeed()},_checkProgress:function(e){return Date.now()-this._lastProgressCallback>=this.uploader.opts.progressCallbacksInterval},_chunkEvent:function(t,e,i){var s=this.uploader,r=u.STATUS,n=this,a=this.getRoot(),o=function(e){n._measureSpeed(e),s._trigger("fileProgress",a,n,t),n._lastProgressCallback=Date.now()};switch(e){case r.PROGRESS:this._checkProgress()&&o();break;case r.ERROR:this._error(),this.abort(!0),s._trigger("fileError",a,this,i,t);break;case r.SUCCESS:if(this._updateUploadedChunks(i,t),this.error)return;clearTimeout(this._progeressId),this._progeressId=0;var h=Date.now()-this._lastProgressCallback;h<s.opts.progressCallbacksInterval&&(this._progeressId=setTimeout(o,s.opts.progressCallbacksInterval-h)),this.isComplete()?(clearTimeout(this._progeressId),o(!0),this.currentSpeed=0,this.averageSpeed=0,s._trigger("fileSuccess",a,this,i,t),a.isComplete()&&s._trigger("fileComplete",a,this)):this._progeressId||o();break;case r.RETRY:s._trigger("fileRetry",a,this,t)}},_updateUploadedChunks:function(t,i){var s=this.uploader.opts.checkChunkUploadedByResponse;s?(n.each(this.chunks,function(e){!e.tested&&s.call(this,e,t)&&(e.xhr=i.xhr),e.tested=!0},this),this._firstResponse?this.uploader.uploadNextChunk():(this._firstResponse=!0,this.uploader.upload(!0))):this.uploader.uploadNextChunk()},_error:function(){this.error=this.allError=!0;for(var e=this.parent;e&&e!==this.uploader;)e._errorFiles.push(this),e.error=!0,e._errorFiles.length===e.files.length&&(e.allError=!0),e=e.parent},_resetError:function(){this.error=this.allError=!1;for(var e=this.parent,t=-1;e&&e!==this.uploader;)t=e._errorFiles.indexOf(this),e._errorFiles.splice(t,1),e.allError=!1,e._errorFiles.length||(e.error=!1),e=e.parent},isComplete:function(){var s=!1;return this._eachAccess(function(e){if(!e.isComplete())return!(s=!0)},function(){var i=u.STATUS;n.each(this.chunks,function(e){var t=e.status();if(t===i.PENDING||t===i.UPLOADING||t===i.READING||1===e.preprocessState||1===e.readState)return!(s=!0)})}),!s},isUploading:function(){var i=!1;return this._eachAccess(function(e){if(e.isUploading())return!(i=!0)},function(){var t=u.STATUS.UPLOADING;n.each(this.chunks,function(e){if(e.status()===t)return!(i=!0)})}),i},resume:function(){this._eachAccess(function(e){e.resume()},function(){this.paused=!1,this.aborted=!1,this.uploader.upload()}),this.paused=!1,this.aborted=!1},pause:function(){this._eachAccess(function(e){e.pause()},function(){this.paused=!0,this.abort()}),this.paused=!0},cancel:function(){this.uploader.removeFile(this)},retry:function(e){e?e.bootstrap():this._eachAccess(function(e){e.error&&e.bootstrap()},function(){this.bootstrap()}),this.uploader.upload()},abort:function(e){if(!this.aborted){this.currentSpeed=0,this.averageSpeed=0,this.aborted=!e;var t=this.chunks;e&&(this.chunks=[]);var i=u.STATUS.UPLOADING;n.each(t,function(e){e.status()===i&&(e.abort(),this.uploader.uploadNextChunk())},this)}},progress:function(){var i=0,s=0,r=0;return this._eachAccess(function(e,t){i+=e.progress()*e.size,s+=e.size,t===this.files.length-1&&(r=0<s?i/s:this.isComplete()?1:0)},function(){if(this.error)r=1;else{if(1===this.chunks.length)return this._prevProgress=Math.max(this._prevProgress,this.chunks[0].progress()),void(r=this._prevProgress);var t=0;n.each(this.chunks,function(e){t+=e.progress()*(e.endByte-e.startByte)});var e=t/this.size;this._prevProgress=Math.max(this._prevProgress,.9999<e?1:e),r=this._prevProgress}}),r},getSize:function(){var t=0;return this._eachAccess(function(e){t+=e.size},function(){t+=this.size}),t},getFormatSize:function(){var e=this.getSize();return n.formatSize(e)},getRoot:function(){if(this.isRoot)return this;for(var e=this.parent;e;){if(e.parent===this.uploader)return e;e=e.parent}return this},sizeUploaded:function(){var t=0;return this._eachAccess(function(e){t+=e.sizeUploaded()},function(){n.each(this.chunks,function(e){t+=e.sizeUploaded()})}),t},timeRemaining:function(){var i=0,s=0,r=0;return this._eachAccess(function(e,t){e.paused||e.error||(s+=e.size-e.sizeUploaded(),r+=e.averageSpeed),t===this.files.length-1&&(i=n(s,r))},function(){if(this.paused||this.error)i=0;else{var e=this.size-this.sizeUploaded();i=n(e,this.averageSpeed)}}),i;function n(e,t){return e&&!t?Number.POSITIVE_INFINITY:e||t?Math.floor(e/t):0}},removeFile:function(e){if(e.isFolder)for(;e.files.length;){var t=e.files[e.files.length-1];this._removeFile(t)}this._removeFile(e)},_delFilePath:function(e){e.path&&this.filePaths&&delete this.filePaths[e.path],n.each(e.fileList,function(e){this._delFilePath(e)},this)},_removeFile:function(i){if(!i.isFolder){n.each(this.files,function(e,t){if(e===i)return this.files.splice(t,1),!1},this),i.abort();for(var e,t=i.parent;t&&t!==this;)e=t.parent,t._removeFile(i),t=e}i.parent===this&&n.each(this.fileList,function(e,t){if(e===i)return this.fileList.splice(t,1),!1},this),this.isRoot||!this.isFolder||this.files.length||(this.parent._removeFile(this),this.uploader._delFilePath(this)),i.parent=null},getType:function(){return this.isFolder?"folder":this.file.type&&this.file.type.split("/")[1]},getExtension:function(){return this.isFolder?"":this.name.substr(2+(~-this.name.lastIndexOf(".")>>>0)).toLowerCase()}}),t.exports=a},{"./chunk":1,"./utils":5}],5:[function(e,t,i){var s=Object.prototype,r=Array.prototype,n=s.toString,l=function(e){return"[object Function]"===n.call(e)},p=Array.isArray||function(e){return"[object Array]"===n.call(e)},c=function(e){return"[object Object]"===n.call(e)&&Object.getPrototypeOf(e)===s},a=0,f={uid:function(){return++a},noop:function(){},bind:function(e,t){return function(){return e.apply(t,arguments)}},preventEvent:function(e){e.preventDefault()},stop:function(e){e.preventDefault(),e.stopPropagation()},nextTick:function(e,t){setTimeout(f.bind(e,t),0)},toArray:function(e,t,i){return void 0===t&&(t=0),void 0===i&&(i=e.length),r.slice.call(e,t,i)},isPlainObject:c,isFunction:l,isArray:p,isObject:function(e){return Object(e)===e},isString:function(e){return"string"==typeof e},isUndefined:function(e){return void 0===e},isDefined:function(e){return void 0!==e},each:function(e,t,i){if(f.isDefined(e.length))for(var s=0,r=e.length;s<r&&!1!==t.call(i,e[s],s,e);s++);else for(var n in e)if(!1===t.call(i,e[n],n,e))break},evalOpts:function(e,t){return f.isFunction(e)&&(t=f.toArray(arguments),e=e.apply(null,t.slice(1))),e},extend:function(){var e,t,i,s,r,n,a=arguments[0]||{},o=1,h=arguments.length,u=!1;for("boolean"==typeof a&&(u=a,a=arguments[1]||{},o++),"object"==typeof a||l(a)||(a={}),o===h&&(a=this,o--);o<h;o++)if(null!=(e=arguments[o]))for(t in e)i=a[t],a!==(s=e[t])&&(u&&s&&(c(s)||(r=p(s)))?(r?(r=!1,n=i&&p(i)?i:[]):n=i&&c(i)?i:{},a[t]=f.extend(u,n,s)):void 0!==s&&(a[t]=s));return a},formatSize:function(e){return e<1024?e.toFixed(0)+" bytes":e<1048576?(e/1024).toFixed(0)+" KB":e<1073741824?(e/1024/1024).toFixed(1)+" MB":(e/1024/1024/1024).toFixed(1)+" GB"},defineNonEnumerable:function(e,t,i){Object.defineProperty(e,t,{enumerable:!1,configurable:!0,writable:!0,value:i})}};t.exports=f},{}]},{},[3])(3)});
//# sourceMappingURL=uploader.min.js.map
